uniform float u_blendFactor;
uniform vec4 u_blendColor;

#define Blend(base, blend, funcf) 		vec3(funcf(base.r, blend.r), funcf(base.g, blend.g), funcf(base.b, blend.b))
#define BlendNormal(base, blend) 		(blend)

vec4 premultiply(vec4 color){
    return vec4(color.r*color.a, color.g*color.a, color.b*color.a, color.a);
}

void main(){
    
    vec4 tintColor = cc_FragColor;
    vec4 texColor = texture2D(cc_MainTexture, cc_FragTexCoord1);
    
    vec4 finalColor = tintColor*texColor;
    
    vec4 blendedColor;
    blendedColor.rgb = u_blendColor.rgb * finalColor.a;
    blendedColor.a = finalColor.a;

    gl_FragColor = mix(finalColor, blendedColor, clamp(u_blendFactor, 0.0,1.0));
    
}
