uniform sampler2D u_NoiseTexture;
uniform float u_greyPercent;

void main(){
        
    // sin wobble
    highp vec2 texCoord = cc_FragTexCoord1;
    highp float time = cc_Time[0];
    highp float yAddition = 0.2*sin(4.0*texCoord.x - (time * 10.0));
    texCoord.y = texCoord.y + (yAddition * texCoord.x);
    
    
    // distortion
    highp vec2 distortionScroll = vec2(-1.0*cc_Time[0], -0.4*cc_Time[1]);
    //vec2 distortionScroll = vec2(-1.0*cc_Time[0], 0.0);
    highp vec2 distortion = texture2D(u_NoiseTexture, vec2(0.7, 0.3)*texCoord + distortionScroll).xy;
    
    distortion.x = pow(distortion.x, 0.5);
    
    //const float xDistort = 0.2;
    const float xDistort = 0.4;
    highp vec2 distortionOffset = texCoord.x*mix(vec2(0.4, -xDistort), vec2(0.0, xDistort), distortion);
    gl_FragColor = cc_FragColor*texture2D(cc_MainTexture, texCoord + distortionOffset);
    
    
    // Grey shader
    float gray = (gl_FragColor.r + gl_FragColor.g + gl_FragColor.b)/3.0;
    //float gray = dot( gl_FragColor.rgb, vec3(0.299, 0.587, 0.114) ); // this is some other NTSC grey blending ...
    gl_FragColor.rgb = mix(gl_FragColor.rgb, vec3(gray), u_greyPercent);
}
