/*uniform vec2 cc_MainTextureSize;
uniform float u_OutlineWidth;

const int SAMPLES = 6;
varying vec2 v_OutlineSamples[SAMPLES];

void main(){
	gl_Position = cc_Position;
	cc_FragColor = clamp(cc_Color, 0.0, 1.0);
	cc_FragTexCoord1 = cc_TexCoord1;
	
	vec2 outlineSize = u_OutlineWidth/cc_MainTextureSize;
	for(int i=0; i<SAMPLES; i++){
		float angle = 2.0*3.14159*float(i)/float(SAMPLES);
		v_OutlineSamples[i] = cc_TexCoord1 + outlineSize*vec2(cos(angle), sin(angle));
	}
}*/

uniform vec2 u_NoiseTexturePixelSize;
uniform float u_AnimationEnabled;
uniform float u_BlockSize;

void main(){
    gl_Position = cc_Position;
    cc_FragColor = clamp(cc_Color, 0.0, 1.0);
    cc_FragTexCoord1 = cc_TexCoord1;
    cc_FragTexCoord2 = cc_TexCoord2;
    
    vec2 screen01 = (0.5*gl_Position.xy/gl_Position.w + 0.5);
    cc_FragTexCoord2 = screen01*cc_ViewSizeInPixels/u_NoiseTexturePixelSize;
    
    vec2 randomAnimatedOffset = cc_Random01.xy*u_AnimationEnabled;
    cc_FragTexCoord2 = (cc_FragTexCoord2 + randomAnimatedOffset)/u_BlockSize;
}
