uniform sampler2D u_maskTexture;
uniform float u_maskWidthRatio;
uniform float u_maskHeightOffset;
uniform float u_maskHeightRatio;

uniform float u_Step;
uniform float u_Radius;
uniform vec2 cc_MainTextureSize;
uniform sampler2D u_NoiseTexture;

vec4 composite(vec4 over, vec4 under){
	return over + (1.0 - over.a)*under;
}

vec4 premultiply(vec4 color){
    return vec4(color.r*color.a, color.g*color.a, color.b*color.a, color.a);
}
vec4 multiply(vec4 color1, vec4 color2){
    return vec4(color1.r+color2.r, color1.g+color2.g, color1.b+color2.b, max(color1.a, color2.a));
}

void main(){
    
    highp float time = cc_Time[0];

    vec2 texCoord = cc_FragTexCoord1;
    texCoord.y += (0.08*sin(0.3*texCoord.x + (time*-50.0)));   //TODO: replace sin with noise function
    gl_FragColor = cc_FragColor*texture2D(cc_MainTexture, texCoord);

    
}
