uniform sampler2D u_maskTexture;
uniform float u_maskWidthRatio;
uniform float u_maskHeightOffset;
uniform float u_maskHeightRatio;

vec4 composite(vec4 over, vec4 under){
	return over + (1.0 - over.a)*under;
}

vec4 premultiply(vec4 color){
    return vec4(color.r*color.a, color.g*color.a, color.b*color.a, color.a);
}


void main(){
	vec4 textureColor = cc_FragColor*texture2D(cc_MainTexture, cc_FragTexCoord1);
	
    vec4 maskColor = texture2D(u_maskTexture, vec2(cc_FragTexCoord1.x*u_maskWidthRatio, (cc_FragTexCoord1.y-u_maskHeightOffset)*u_maskHeightRatio));
    
    
    //textureColor = predivide(textureColor);
    //vec4 finalColor = vec4(textureColor.r, textureColor.g, textureColor.b, textureColor.a * maskColor.a);
    
    gl_FragColor = textureColor * maskColor.a;
    
    //gl_FragColor = premultiply(finalColor);
}
