uniform sampler2D u_hex_texture;

varying highp vec2 cc_innerTexcood;
varying lowp vec4 cc_innerColor;
varying lowp vec4 cc_noiseColor;

vec4 composite(vec4 over, vec4 under){
    return over + (1.0 - over.a)*under;
}

void main(){
    
    vec4 outerColor = cc_FragColor*cc_noiseColor*texture2D(cc_MainTexture, cc_FragTexCoord1);
    
    vec4 innerColor = cc_FragColor*cc_innerColor*texture2D(u_hex_texture, cc_innerTexcood);
    
    
    gl_FragColor = cc_FragColor*composite(innerColor, outerColor);
    
    //gl_FragColor = cc_FragColor*texture2D(cc_MainTexture, cc_FragTexCoord1);
    //gl_FragColor = cc_FragColor;
}
