uniform sampler2D u_NoiseTexture;

void main() {
    
    highp vec2 position = cc_Position.xy;
    highp float time = cc_Time[0];
    float offset = 1.0 - (smoothstep(0.7,1.0,cc_Color.a));
    
    highp float noise1 = (texture2D(u_NoiseTexture, vec2(cc_TexCoord1.y*0.03, (time*0.3))).x) - 0.5;
    vec2 noiseAdditionVector =  (noise1*offset) * ((cc_TexCoord2 - position) * 8.0);
    
    
    noiseAdditionVector = noiseAdditionVector * ((cc_TexCoord1.x*2.0)-1.0);
    
    
    vec2 wobblePositionVector = vec2(cc_Position.x+noiseAdditionVector.x, cc_Position.y+noiseAdditionVector.y);
    
    //float offset2 = 1.0 - (smoothstep(0.0,0.3,cc_Color.a));
    float offset2 = 1.0 - (clamp(cc_Color.a*3.0, 0.0, 1.0));
    
    vec2 mixedVector = mix(wobblePositionVector,cc_TexCoord2, offset2);
    
    gl_Position = vec4(mixedVector.x, mixedVector.y, cc_Position.z, cc_Position.w);
    
    
    cc_FragColor = clamp(cc_Color, 0.0, 1.0);
    cc_FragTexCoord1 = cc_TexCoord1;
    cc_FragTexCoord2 = cc_TexCoord2;
}
