uniform sampler2D u_NoiseTexture;

void main() {
    
    highp vec2 position = cc_Position.xy;
    highp float time = cc_Time[0];
    float offset = 1.0 - (smoothstep(0.7,1.0,cc_Color.a));
    
    highp float noise1 = (texture2D(u_NoiseTexture, vec2(cc_TexCoord1.y*0.02, (time*0.3))).x) - 0.5;
    //vec2 noiseAdditionVector = ((noise1*0.1)*offset) * (position - cc_TexCoord2);
    vec2 noiseAdditionVector =  (noise1*offset) * ((cc_TexCoord2 - position) * 4.0);
    //gl_Position = vec4(cc_Position.x, cc_Position.y+((noise1*0.1)*offset), cc_Position.z, cc_Position.w);
    
    gl_Position = vec4(cc_Position.x+noiseAdditionVector.x, cc_Position.y+noiseAdditionVector.y, cc_Position.z, cc_Position.w);
    
    cc_FragColor = clamp(cc_Color, 0.0, 1.0);
    cc_FragTexCoord1 = cc_TexCoord1;
    cc_FragTexCoord2 = cc_TexCoord2;
}
