uniform sampler2D u_maskTexture;
uniform float u_maskWidthRatio;
uniform float u_maskHeightOffset;
uniform float u_maskHeightRatio;

uniform float u_rayWidth;
uniform float u_rayHeight;
uniform float u_widthHeightRatio;
uniform float u_contentScale;

vec4 composite(vec4 over, vec4 under){
	return over + (1.0 - over.a)*under;
}
vec4 premultiply(vec4 color){
    return vec4(color.r*color.a, color.g*color.a, color.b*color.a, color.a);
}
vec4 predivide(vec4 color){
    //TODO: optimize this???
    if(color.a != 0.0) {
        color.rgb /= color.a;
        return color;
    }
    
    // else
    return color;
}

float GodRay(vec2 uv,float scale,float threshold,float speed,float angle){
    
    float value = pow(sin((uv.x+uv.y/u_widthHeightRatio*angle+cc_Time[1]*speed)*scale),1.0);
    
    //float value = pow(sin((uv.x+uv.y*angle+cc_Time[1]*speed)*scale),6.0);
    
    value+=float(threshold<value);
    //return float(threshold<(sin((uv.x+uv.y*angle+iGlobalTime*speed)*scale)));
    return clamp(value,0.0,1.0);
}


void main(){
	vec4 textureColor = cc_FragColor*texture2D(cc_MainTexture, vec2(cc_FragTexCoord1.x + (cc_Time[1]*1.0), cc_FragTexCoord1.y));
	
    
    vec4 maskColor = texture2D(u_maskTexture, vec2(cc_FragTexCoord1.x*u_maskWidthRatio, ((cc_FragTexCoord1.y-u_maskHeightOffset)*u_maskHeightRatio) ));
    
    
    textureColor = predivide(textureColor);
    vec4 finalColor = vec4(textureColor.r, textureColor.g, textureColor.b, textureColor.a * maskColor.a);
    

//    gl_FragColor = premultiply(vec4(finalColor.rgb,finalColor.a)); // this takes off the godray
//    return;
    //finalColor = textureColor; // this disables the mask
    
    vec2 uv = vec2(cc_FragTexCoord1.x*u_maskWidthRatio, (cc_FragTexCoord1.y-u_maskHeightOffset)*u_maskHeightRatio);
    
    float light = GodRay(uv,u_rayWidth*u_contentScale,0.5,-0.3*u_maskWidthRatio,-0.4)*	0.3; // b
    //light+=GodRay(uv,25.0,0.9,		-0.01,	0.2)*	0.2;
    //light+=GodRay(uv,200.0,0.8,	-0.0001,0.2)*	0.05;
    //light+=GodRay(uv,49.0,	0.4,	0.0003,	0.2)*	0.1;
    //light+=GodRay(uv,57.0,	0.4,	-0.0001,0.2)*	0.1;
    //light+=GodRay(uv,200.0,0.8,	-0.0001,0.2)*	0.05;
    //light-=pow((uv.y)*0.3,0.8); // these need to be scaled right
    light-=pow((uv.y)*0.3,0.8); // these need to be scaled right
    
    
    vec3 LightColor = vec3(0.7,0.75,0.95);  // these need to be scaled right
    
    vec4 WaterColor = finalColor;
    
//    light = 1.0;
    light=clamp(light,0.001,0.99); // clamp
    
    vec3 Color = WaterColor.rgb+ (light*(LightColor-WaterColor.rgb));
    
    gl_FragColor = premultiply(vec4(Color,WaterColor.a));
}
